<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2007 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * $Source: /home/www/dps3311/home/cvsroot/pragmamx/pragmamx_01/admin/modules/versioncheck.php,v $
 * $Revision: 1.19 $
 * $Author: tora60 $
 * $Date: 2007/06/04 08:38:38 $
 */

@ini_set("max_execution_time", 0);
@set_time_limit(0);
@ini_set("allow_url_fopen", "1");

$verfile = 'http://version.pragmamx.de/pragma_stable/version_' . preg_replace('#\s{1,}#', '_', MX_VERSION);
$verlocal = 'includes/versioncontrol.php';

/**
 * globale Fehlermeldung
 */
$GLOBALS['verrormessage'] = array();

/**
 * Dateien und Ordner, die nicht gecheckt werden sollen.
 */
$excludes = array('setup',
    'install',
    'themes',
    'upgrade',
    'themecache',

    'config.php',
    'create-cvs.php',
    'hs~create-cvs.php',
    'develop.php',
    'secureurl.class.php',
    'unlock.php',
    'upgrade.php',

    'admin/modules/download.php',
    'admin/modules/links.php',
    'admin/modules/gallery/config.php',
    'admin/modules/gallery/install.php',
    'blocks/block-Menu_editable.php',
    'includes/captcha/settings.php',
    'includes/detection/config.php',
    'includes/jpcache/jpcache-config.php',
    'includes/mx_userfunctions_options.php',
    'includes/mx_userfunctions_options.sample.php',
    'includes/mxRelatedArray.php',
    'includes/my_header.php',
    'includes/rewrite/eboard.php',
    'includes/rewrite/smf.php',
    'includes/userip_ban.php',
    'includes/versioncontrol.php',
    'modules/Downloads/d_config.php',
    'modules/Downloads/voteinclude.php',
    'modules/Guestbook/include/config.inc.php',
    'modules/legal/Version.php',
    'modules/Private_Messages/config.php',
    'modules/Reviews/config.php',
    'modules/Topics/config.inc.php',
    'modules/UserGuest/settings.php',
    'modules/Web_Links/l_config.php',
    'modules/Web_Links/voteinclude.php',
    'modules/Web_News/config.inc.php',
    'modules/Your_Account/config.php',
    'spaw/editor_cnf.php',
    );
// allgemeine Datei und Ordnernamen, die nirgends beachtet werden
$exfiles = array('.',
    '..',
    'CVS',
    '.cvsignore',
    '.htaccess',
    'index.html',
    );
// Sprachdateien, deren Hauptsprachdatei fehlt, ebenfalls nicht beachten
$languages = array('german', 'german_du', 'french', 'english', 'turkish', 'spanish');
foreach($languages as $lang) {
    $exfiles[] = 'hello-' . $lang . '.php';
    $exfiles[] = 'option-' . $lang . '.php';
    $exfiles[] = 'option-' . $lang . '.sample.php';
    if (!@file_exists('language/lang-' . $lang . '.php')) {
        $exfiles[] = 'lang-' . $lang . '.php';
        $exfiles[] = 'maaXoN-' . $lang . '.php';
        $exfiles[] = 'hello-' . $lang . '.php';
    } 
} 
// Die Kontrolldatei auslesen
$verfiles = getVersionInfo();

$out = '';
$i = 0;
if (isset($verfiles['files'])) {
    $myfiles = @getDirContents('./');
    foreach ($verfiles['files'] as $file => $value) {
        if (in_array($file, $GLOBALS['excludes'])) {
            continue;
        } 
        if (!isset($myfiles[$file])) {
            if (!isset($_GET['showall'])) {
                continue;
            } 
            $tmp = explode('/', $file);
            if (in_array(array_pop($tmp), $GLOBALS['exfiles'])) {
                continue;
            } 
            $soll = '<span style="color: Red;">??</span>';
            $msg = '<span style="color: Red;">' . _VERCHECK_01 . '</span>';
        } else {
            $version = $value['version'];
            if (empty($myfiles[$file]['version']) && !empty($version)) {
                $soll = '<span style="color: Red;">??</span>';
                $msg = '<span style="color: Red;">' . _VERCHECK_02 . ' ' . _VERCHECK_07 . '</span>';
            } else if ($myfiles[$file]['version'] != $version) {
                $xx = version_compare($myfiles[$file]['version'], $version);
                $xx = ($xx == 1) ? '<span style="color:green;">' . _VERCHECK_03 . '</span>' : _VERCHECK_04;
                $soll = '<span style="color: Red;">' . $myfiles[$file]['version'] . '</span>';
                $msg = '<span style="color: Red;">' . $xx . ' ' . _VERCHECK_07 . '</span>';
            } else if ($myfiles[$file]['md5'] != $value['md5']) {
                $xx = filemtime($file);
                if ($xx) {
                    $xx = '<br><span style="font-size: 80%;">' . mx_strftime(_SHORTDATESTRING . ' %H:%M', $xx) . '</span>';
                } 
                $soll = '<span style="color: blue;">' . $myfiles[$file]['version'] . '</span>';
                $msg = '<span style="color: blue;">' . _VERCHECK_05 . $xx . '</span>';
            } else {
                if (!isset($_GET['showall'])) {
                    continue;
                } 
                $soll = $myfiles[$file]['version'];
                $msg = '&nbsp;';
                $msg = '<span style="color: green;">' . _VERCHECK_06 . '</span>';
            } 
        } 
        $version = (empty($version)) ? '??' : $version;
        $out .= '<tr><td>' . $file . '</td><td>' . $version . '</td><td>' . $soll . '</td><td>' . $msg . '</td></tr>';
        $i++; 
        // if ($i == 30) break;
    } 
} 

if (isset($_GET['showall'])) {
    $otherlink = '<a href="admin.php?op=mxvcheck">' . _VERCHECK_14 . '</a>';
} else {
    $otherlink = '<a href="admin.php?op=mxvcheck&amp;showall">' . _VERCHECK_13 . '</a>';
} 

include('header.php');
title(MX_VERSION . ' ' . _VERCHECK_00 . '');
openTable();
echo '<p align="right"><img src="images/menu/oarrow.gif" alt="" border="0">&nbsp;' . $otherlink . '</p>';
if ($i) {
    echo '<table border="1" cellspacing="0" cellpadding="2" align="center">
	<tr><th>' . _VERCHECK_08 . '</th><th>' . _VERCHECK_09 . '</th><th>' . _VERCHECK_10 . '</th><th>' . _VERCHECK_11 . '</th><!-- <th>' . _VERCHECK_12 . '</th> --></tr>
	' . $out . '
	</table>';
} else if (!isset($verfiles['files'])) {
    echo '<h2 align="center">' . _VERCHECK_16 . '</h2>';
} else {
    echo '<h2 align="center">' . _VERCHECK_15 . '</h2>';
} 

if (count($GLOBALS['verrormessage'])) {
    echo '<ul><li>' . implode('</li><li>', $GLOBALS['verrormessage']) . '</li></ul>';
} 

echo '<p align="right" class="tiny"><br><br><br><br><br><br>' . basename($verfile) . '</p>';
closeTable();
include('footer.php');

/**
 * ermittelt rekursiv die Daten des angegebenen Ordners
 */
function getDirContents($dir)
{ 
    // Rueckgabearray initialisieren
    $files = array(); 
    // sicherstellen, dass der Pfad einen Slash am Ende hat und Backslashes durch normale ersetzt werden
    $dir = str_replace(DIRECTORY_SEPARATOR, '/', trim($dir, '/' . DIRECTORY_SEPARATOR) . '/'); 
    // Resource erstellen
    $root = opendir($dir); 
    // wenn Ordner-Resourece erstellt werden konnte
    if ($root) {
        // wenn aktueller Ordner, dann $dir leeren, damit die Pfade spaeter stimmen
        if ($dir === './') {
            $dir = '';
        } 
        // Schleife durch Ordner
        while ($file = readdir($root)) {
            // Datei soll unabhaengig vom Pfad ignoriert werden, einfach weiter
            if (in_array($file, $GLOBALS['exfiles'])) {
                continue;
            } 
            // den Pfad vor den Dateinamen setzen
            $newfile = $dir . $file; 
            // Dateipfad soll ignoriert werden, einfach weiter
            if (in_array($newfile, $GLOBALS['excludes'])) {
                continue;
            } 
            // Dateipfad ist vorhanden
            if (is_file($newfile)) {
                // nur bestimmte Dateiendungen beachten
                if (!preg_match('#\.(php|js|inc)$#i', $file)) {
                    continue;
                } 
                // Inhalt der Datei lesen und zwischenspeichern
                $tmp = @file_get_contents($newfile); 
                // Versionsnummer aus dem Dateiinhalt, bzw. CVS-Header auslesen
                preg_match('#\$Revision\:[[:space:]]*([0-9\.]*)[[:space:]]*\$#i', $tmp, $matches);
                if (empty($matches[1])) {
                    // alte Version des CVS-Headers
                    preg_match('#\$Id\:.*\.(?:php|js),v[[:space:]]*([0-9\.]*)[[:space:]]*.*\$#i', $tmp, $matches);
                } 
                // Die Versionsinformationen aus dem Dateiinhalt entfernen
                $tmp = preg_replace('#\$(?:Source|Revision|Author|Date):\s.+\s\$#mi', '', $tmp); 
                // den md5 String des Dateinhalts im Ausgabearray zwischenspeichern
                // daraus vorher alle Leer und Steuerzeichen entfernen
                $files[$newfile]['md5'] = md5(trim(preg_replace('#[[:space:][:cntrl:]]#', '', $tmp))); 
                // falls keine Versionsinfo vorhanden, diese auf 0 setzen
                $tmp = (empty($matches[1])) ? '0' : $matches[1]; 
                // die ermittelte Version ebenfalls im Ausgabearray speichern
                $files[$newfile]['version'] = $tmp;
            } else {
                // Verknuepfungen werden ignoriert
                if (@!is_link($newfile)) {
                    // Ordner rekusiv durchlaufen, das Ausgabearray entsprechend erweitern
                    $files = array_merge($files, getDirContents($newfile . '/'));
                } 
            } 
        } 
    } else {
        // wenn Ordner-Resource nicht erstellt werden konnte, Fehlermeldung zurueckgeben
        $GLOBALS['verrormessage'][] = sprintf(_VERCHECK_17, $dir);
    } 
    return $files;
} 

/**
 * ermittelt die Referenzdaten anhand der remote Datei auf pragmaMx.org
 * kann diese nicht eingelesen werden, wird die lokale Datei verwendet
 */
function getVersionInfo()
{
    global $verfile, $verlocal; 
    // interne Variablen initialisieren
    $sysver = array();
    $file_contents = ""; 
    // allow_url_fopen ist seit php 5.1 nur noch PER_DIR einstellbar.
    @ini_set("allow_url_fopen", "1"); 
    // Ist es abgeschaltet, funktioniert file() nicht
    if (is_callable('curl_init')) {
        // mxDebugFuncVars(1);
        // wenn mglich die curl-Biblithek verwenden
        $ch = curl_init();
        $timeout = 20; // set to zero for no timeout
        curl_setopt ($ch, CURLOPT_URL, $verfile);
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        $file_contents = curl_exec($ch);
        curl_close($ch);
    } else if (@include($verfile)) {
        // mxDebugFuncVars(2);
        @ini_restore("allow_url_fopen");
        return unserialize($sysver);
    } else if ($data = @file($verfile)) {
        // mxDebugFuncVars(3);
        $file_contents = implode('', $data); // Put data into an array
    } else {
        // mxDebugFuncVars(4);
        // ansonsten die herkmmliche Methode von nuke/pragmaMx verwenden
        $errno = '';
        $errstr = '';
        $v_file = parse_url($verfile);
        $v_file['host'] = strtolower($v_file['host']);
        $fp = @fsockopen($v_file['host'], 80, $errno, $errstr, 15);
        if ($fp) {
            if (!isset($v_file['query'])) {
                $v_file['query'] = "";
            } 
            fputs($fp, "GET " . $v_file['path'] . "?" . $v_file['query'] . " HTTP/1.0\r\n");
            fputs($fp, "HOST: " . $v_file['host'] . "\r\n\r\n");
            while (!feof($fp)) {
                $pagetext = fgets($fp, 16777216);
                $file_contents .= trim($pagetext);
            } 
            fputs($fp, "Connection: close\r\n\r\n");
            fclose($fp);
        } else {
            $GLOBALS['verrormessage'][] = _VERCHECK_18 . '&nbsp;&nbsp;' . $errno . ', ' . $errstr . ' ';
        } 
    } 
    @ini_restore("allow_url_fopen");

    if ($file_contents) {
        preg_match("#='([^']*)'#", $file_contents, $matches);
        if (!empty($matches[1])) {
            $sysver = unserialize($matches[1]);
        } 
    } else if (@file_exists($verlocal)) {
        $GLOBALS['verrormessage'][] = _VERCHECK_16;
        if (include($verlocal)) {
            $sysver = unserialize($sysver);
        } 
    } else {
        $GLOBALS['verrormessage'][] = sprintf(_VERCHECK_19, $verlocal);
    } 
    return $sysver;
} 

?>